# Reference

<!-- DO NOT EDIT: This document was generated by Puppet Strings -->

## Table of Contents

### Classes

* [`fluentbit`](#fluentbit)
* [`fluentbit::config`](#fluentbit--config): configures the main fluentbit main config
* [`fluentbit::install`](#fluentbit--install): Installs fluentbit package
* [`fluentbit::repo`](#fluentbit--repo): Setup the fluentbit repo
* [`fluentbit::repo::debian`](#fluentbit--repo--debian): Manage fluentbit apt repo
* [`fluentbit::repo::redhat`](#fluentbit--repo--redhat): Manage yum repo
* [`fluentbit::service`](#fluentbit--service): Manage fluent-bit service

### Defined types

* [`fluentbit::pipeline`](#fluentbit--pipeline): Configures fluentbit pipeline (input, output or filter)
* [`fluentbit::upstream`](#fluentbit--upstream): Configures fluentbit upstream

### Data types

* [`Fluentbit::Field_decoder`](#Fluentbit--Field_decoder)
* [`Fluentbit::Field_type`](#Fluentbit--Field_type)
* [`Fluentbit::Loglevel`](#Fluentbit--Loglevel)
* [`Fluentbit::MultilineParser`](#Fluentbit--MultilineParser)
* [`Fluentbit::Parser`](#Fluentbit--Parser)
* [`Fluentbit::PipelinePlugin`](#Fluentbit--PipelinePlugin)
* [`Fluentbit::PipelineType`](#Fluentbit--PipelineType)
* [`Fluentbit::Stream`](#Fluentbit--Stream)
* [`Fluentbit::UpstreamNode`](#Fluentbit--UpstreamNode)

## Classes

### <a name="fluentbit"></a>`fluentbit`

The fluentbit class.

#### Examples

##### 

```puppet
include fluentbit
```

#### Parameters

The following parameters are available in the `fluentbit` class:

* [`manage_storage_dir`](#-fluentbit--manage_storage_dir)
* [`config_dir`](#-fluentbit--config_dir)
* [`plugins_dir`](#-fluentbit--plugins_dir)
* [`scripts_dir`](#-fluentbit--scripts_dir)
* [`data_dir`](#-fluentbit--data_dir)
* [`binary_file`](#-fluentbit--binary_file)
* [`config_file`](#-fluentbit--config_file)
* [`config_file_mode`](#-fluentbit--config_file_mode)
* [`config_folder_mode`](#-fluentbit--config_folder_mode)
* [`storage_path`](#-fluentbit--storage_path)
* [`storage_sync`](#-fluentbit--storage_sync)
* [`storage_checksum`](#-fluentbit--storage_checksum)
* [`storage_backlog_mem_limit`](#-fluentbit--storage_backlog_mem_limit)
* [`storage_max_chunks_up`](#-fluentbit--storage_max_chunks_up)
* [`storage_metrics`](#-fluentbit--storage_metrics)
* [`storage_delete_irrecoverable_chunks`](#-fluentbit--storage_delete_irrecoverable_chunks)
* [`health_check`](#-fluentbit--health_check)
* [`hc_errors_count`](#-fluentbit--hc_errors_count)
* [`hc_retry_failure_count`](#-fluentbit--hc_retry_failure_count)
* [`hc_period`](#-fluentbit--hc_period)
* [`manage_plugins_file`](#-fluentbit--manage_plugins_file)
* [`plugins_file`](#-fluentbit--plugins_file)
* [`plugins`](#-fluentbit--plugins)
* [`manage_streams_file`](#-fluentbit--manage_streams_file)
* [`streams_file`](#-fluentbit--streams_file)
* [`streams`](#-fluentbit--streams)
* [`upstreams`](#-fluentbit--upstreams)
* [`manage_parsers_file`](#-fluentbit--manage_parsers_file)
* [`parsers_file`](#-fluentbit--parsers_file)
* [`parsers`](#-fluentbit--parsers)
* [`multiline_parsers`](#-fluentbit--multiline_parsers)
* [`flush`](#-fluentbit--flush)
* [`grace`](#-fluentbit--grace)
* [`daemon`](#-fluentbit--daemon)
* [`dns_mode`](#-fluentbit--dns_mode)
* [`log_level`](#-fluentbit--log_level)
* [`http_server`](#-fluentbit--http_server)
* [`http_listen`](#-fluentbit--http_listen)
* [`http_port`](#-fluentbit--http_port)
* [`coro_stack_size`](#-fluentbit--coro_stack_size)
* [`scheduler_cap`](#-fluentbit--scheduler_cap)
* [`scheduler_base`](#-fluentbit--scheduler_base)
* [`json_convert_nan_to_null`](#-fluentbit--json_convert_nan_to_null)
* [`variables`](#-fluentbit--variables)
* [`manage_package_repo`](#-fluentbit--manage_package_repo)
* [`package_ensure`](#-fluentbit--package_ensure)
* [`package_name`](#-fluentbit--package_name)
* [`manage_service`](#-fluentbit--manage_service)
* [`service_enable`](#-fluentbit--service_enable)
* [`service_has_status`](#-fluentbit--service_has_status)
* [`service_restart_command`](#-fluentbit--service_restart_command)
* [`service_has_restart`](#-fluentbit--service_has_restart)
* [`service_override_unit_file`](#-fluentbit--service_override_unit_file)
* [`service_ensure`](#-fluentbit--service_ensure)
* [`service_name`](#-fluentbit--service_name)
* [`manage_config_dir`](#-fluentbit--manage_config_dir)
* [`manage_data_dir`](#-fluentbit--manage_data_dir)
* [`inputs`](#-fluentbit--inputs)
* [`outputs`](#-fluentbit--outputs)
* [`filters`](#-fluentbit--filters)
* [`memory_max`](#-fluentbit--memory_max)

##### <a name="-fluentbit--manage_storage_dir"></a>`manage_storage_dir`

Data type: `Boolean`

Whether to manage the storage directory. `storage_path` must be defined.
Default value: true

##### <a name="-fluentbit--config_dir"></a>`config_dir`

Data type: `Stdlib::Absolutepath`

Absolute path to directory where configuration files are stored.

##### <a name="-fluentbit--plugins_dir"></a>`plugins_dir`

Data type: `String`

Directory name for plugins, relative to @config_dir

##### <a name="-fluentbit--scripts_dir"></a>`scripts_dir`

Data type: `String`

Directory name for scripts, relative to @config_dir

##### <a name="-fluentbit--data_dir"></a>`data_dir`

Data type: `Stdlib::Absolutepath`

Path to data directory that will be used by plugins using DB feature.

##### <a name="-fluentbit--binary_file"></a>`binary_file`

Data type: `Stdlib::Absolutepath`

Path of the daemon binary.

##### <a name="-fluentbit--config_file"></a>`config_file`

Data type: `Stdlib::Absolutepath`

Path of the daemon configuration.

##### <a name="-fluentbit--config_file_mode"></a>`config_file_mode`

Data type: `Stdlib::Filemode`

File mode to apply to the daemon configuration file

##### <a name="-fluentbit--config_folder_mode"></a>`config_folder_mode`

Data type: `Stdlib::Filemode`

File mode to apply folders managed by the module

##### <a name="-fluentbit--storage_path"></a>`storage_path`

Data type: `Optional[Stdlib::Absolutepath]`

Set an optional location in the file system to store streams and chunks of data.
If this parameter is not set, Input plugins can only use in-memory buffering.

##### <a name="-fluentbit--storage_sync"></a>`storage_sync`

Data type: `Optional[Enum['normal', 'full']]`

Configure the synchronization mode used to store the data into the file system.
It can take the values normal or full.
Default value: 'normal'

##### <a name="-fluentbit--storage_checksum"></a>`storage_checksum`

Data type: `Boolean`

Enable the data integrity check when writing and reading data from the filesystem.
The storage layer uses the CRC32 algorithm.
Default value: false

##### <a name="-fluentbit--storage_backlog_mem_limit"></a>`storage_backlog_mem_limit`

Data type: `Optional[String[1]]`

If the input plugin has enabled filesystem storage type, this property sets the maximum
number of Chunks that can be up in memory.
This is the setting to use to control memory usage when you enable storage.type filesystem.
Default value: 128

##### <a name="-fluentbit--storage_max_chunks_up"></a>`storage_max_chunks_up`

Data type: `Optional[Integer]`

If storage.path is set, Fluent Bit will look for data chunks that were
not delivered and are still in the storage layer, these are called backlog data.
This option configure a hint of maximum value of memory to use when processing these records.
Default value: 5M

##### <a name="-fluentbit--storage_metrics"></a>`storage_metrics`

Data type: `Boolean`

If http_server option has been enabled in the main [SERVICE] section, this option registers a new
endpoint where internal metrics of the storage layer can be consumed.
Default value: false

##### <a name="-fluentbit--storage_delete_irrecoverable_chunks"></a>`storage_delete_irrecoverable_chunks`

Data type: `Boolean`

When enabled, irrecoverable chunks will be deleted during runtime, and any other irrecoverable chunk
located in the configured storage path directory will be deleted when Fluent-Bit starts.
Default value: false

##### <a name="-fluentbit--health_check"></a>`health_check`

Data type: `Boolean`

Enable or disable health_check
Default Off

##### <a name="-fluentbit--hc_errors_count"></a>`hc_errors_count`

Data type: `Integer`

Only in use if health_check is enabled. The error count after which the healcheck returns an error.
Default 5

##### <a name="-fluentbit--hc_retry_failure_count"></a>`hc_retry_failure_count`

Data type: `Integer`

Only in use if health_check is enabled. Retry count till a check returns an error
Default 5

##### <a name="-fluentbit--hc_period"></a>`hc_period`

Data type: `Integer`

Only in use if health_check is enabled. Time period by second to count the error and retry failure data point
Default 60

##### <a name="-fluentbit--manage_plugins_file"></a>`manage_plugins_file`

Data type: `Boolean`

Whether to manage the enabled external plugins

##### <a name="-fluentbit--plugins_file"></a>`plugins_file`

Data type: `Stdlib::Absolutepath`

A plugins configuration file allows to define paths for external plugins.

##### <a name="-fluentbit--plugins"></a>`plugins`

Data type: `Array[Stdlib::Absolutepath]`

List of external plugin objects to enable

Default value: `[]`

##### <a name="-fluentbit--manage_streams_file"></a>`manage_streams_file`

Data type: `Boolean`

Whether to manage the stream processing configuration

##### <a name="-fluentbit--streams_file"></a>`streams_file`

Data type: `Stdlib::Absolutepath`

Path for the Stream Processor configuration file.

##### <a name="-fluentbit--streams"></a>`streams`

Data type: `Fluentbit::Stream`

Stream processing tasks

Default value: `{}`

##### <a name="-fluentbit--upstreams"></a>`upstreams`

Data type: `Hash[String, Hash]`

Upstreams used by forward plugins

Default value: `{}`

##### <a name="-fluentbit--manage_parsers_file"></a>`manage_parsers_file`

Data type: `Boolean`

Whether to manage the parser definitions

##### <a name="-fluentbit--parsers_file"></a>`parsers_file`

Data type: `Stdlib::Absolutepath`

Path for a parsers configuration file. Multiple Parsers_File entries can be used.

##### <a name="-fluentbit--parsers"></a>`parsers`

Data type: `Fluentbit::Parser`

List of parser definitions.
The default value consists of all the available definitions provided by the
upstream project as of version 1.3

##### <a name="-fluentbit--multiline_parsers"></a>`multiline_parsers`

Data type: `Fluentbit::MultilineParser`

List of parser definitions.
The default value consists of all the available definitions provided by the
upstream project as of version 2.1

Default value: `{}`

##### <a name="-fluentbit--flush"></a>`flush`

Data type: `Integer`

Set the flush time in seconds. Everytime it timeouts, the engine will flush the records to the output plugin.

##### <a name="-fluentbit--grace"></a>`grace`

Data type: `Integer`

Set the grace time in seconds. The engine loop uses a Grace timeout to define the wait time on exit.

##### <a name="-fluentbit--daemon"></a>`daemon`

Data type: `Boolean`

Boolean value to set if Fluent Bit should run as a Daemon (background) or not. Allowed values are: yes, no, on and off.

##### <a name="-fluentbit--dns_mode"></a>`dns_mode`

Data type: `Enum['UDP', 'TCP']`

Sets the primary transport layer protocol used by the asynchronous DNS resolver.

##### <a name="-fluentbit--log_level"></a>`log_level`

Data type: `Fluentbit::Loglevel`

Set the logging verbosity level.
Values are: error, info, debug and trace. Values are accumulative,
e.g: if 'debug' is set, it will include error, info and debug.
Note that trace mode is only available if Fluent Bit was built with the WITH_TRACE option enabled.

##### <a name="-fluentbit--http_server"></a>`http_server`

Data type: `Boolean`

Enable built-in HTTP Server

##### <a name="-fluentbit--http_listen"></a>`http_listen`

Data type: `Stdlib::IP::Address::Nosubnet`

Set listening interface for HTTP Server when it's enabled

##### <a name="-fluentbit--http_port"></a>`http_port`

Data type: `Stdlib::Port`

Set TCP Port for the HTTP Server

##### <a name="-fluentbit--coro_stack_size"></a>`coro_stack_size`

Data type: `Integer`

Set the coroutines stack size in bytes.
The value must be greater than the page size of the running system.

##### <a name="-fluentbit--scheduler_cap"></a>`scheduler_cap`

Data type: `Integer`

Set a maximum retry time in seconds. The property is supported from v1.8.7.

##### <a name="-fluentbit--scheduler_base"></a>`scheduler_base`

Data type: `Integer`

Sets the base of exponential backoff. The property is supported from v1.8.7.

##### <a name="-fluentbit--json_convert_nan_to_null"></a>`json_convert_nan_to_null`

Data type: `Boolean`

If enabled, NaN is converted to null when fluent-bit converts msgpack to json.

##### <a name="-fluentbit--variables"></a>`variables`

Data type: `Hash`

macro definitions to use in the configuration file
the will be registered using the *@SET* command or using Env section in YAML syntax.

Default value: `{}`

##### <a name="-fluentbit--manage_package_repo"></a>`manage_package_repo`

Data type: `Boolean`



##### <a name="-fluentbit--package_ensure"></a>`package_ensure`

Data type: `String[1]`



##### <a name="-fluentbit--package_name"></a>`package_name`

Data type: `String[1]`



##### <a name="-fluentbit--manage_service"></a>`manage_service`

Data type: `Boolean`



##### <a name="-fluentbit--service_enable"></a>`service_enable`

Data type: `Boolean`



##### <a name="-fluentbit--service_has_status"></a>`service_has_status`

Data type: `Boolean`



##### <a name="-fluentbit--service_restart_command"></a>`service_restart_command`

Data type: `Optional[String[1]]`



##### <a name="-fluentbit--service_has_restart"></a>`service_has_restart`

Data type: `Boolean`



##### <a name="-fluentbit--service_override_unit_file"></a>`service_override_unit_file`

Data type: `Boolean`



##### <a name="-fluentbit--service_ensure"></a>`service_ensure`

Data type: `Stdlib::Ensure::Service`



##### <a name="-fluentbit--service_name"></a>`service_name`

Data type: `String[1]`



##### <a name="-fluentbit--manage_config_dir"></a>`manage_config_dir`

Data type: `Boolean`



##### <a name="-fluentbit--manage_data_dir"></a>`manage_data_dir`

Data type: `Boolean`



##### <a name="-fluentbit--inputs"></a>`inputs`

Data type: `Fluentbit::PipelinePlugin`



Default value: `{}`

##### <a name="-fluentbit--outputs"></a>`outputs`

Data type: `Fluentbit::PipelinePlugin`



Default value: `{}`

##### <a name="-fluentbit--filters"></a>`filters`

Data type: `Fluentbit::PipelinePlugin`



Default value: `{}`

##### <a name="-fluentbit--memory_max"></a>`memory_max`

Data type: `Optional[String[1]]`



Default value: `undef`

### <a name="fluentbit--config"></a>`fluentbit::config`

configures the main fluentbit main config

#### Parameters

The following parameters are available in the `fluentbit::config` class:

* [`config_dir`](#-fluentbit--config--config_dir)
* [`plugins_path`](#-fluentbit--config--plugins_path)
* [`scripts_path`](#-fluentbit--config--scripts_path)

##### <a name="-fluentbit--config--config_dir"></a>`config_dir`

Data type: `Stdlib::Absolutepath`

Absolute path to main configuration directory

Default value: `$fluentbit::config_dir`

##### <a name="-fluentbit--config--plugins_path"></a>`plugins_path`

Data type: `Stdlib::Absolutepath`



Default value: `$fluentbit::plugins_path`

##### <a name="-fluentbit--config--scripts_path"></a>`scripts_path`

Data type: `Stdlib::Absolutepath`



Default value: `$fluentbit::scripts_path`

### <a name="fluentbit--install"></a>`fluentbit::install`

Installs fluentbit package

### <a name="fluentbit--repo"></a>`fluentbit::repo`

Setup the fluentbit repo

### <a name="fluentbit--repo--debian"></a>`fluentbit::repo::debian`

Manage fluentbit apt repo

#### Parameters

The following parameters are available in the `fluentbit::repo::debian` class:

* [`key_fingerprint`](#-fluentbit--repo--debian--key_fingerprint)
* [`key_location`](#-fluentbit--repo--debian--key_location)
* [`flavour`](#-fluentbit--repo--debian--flavour)
* [`release`](#-fluentbit--repo--debian--release)

##### <a name="-fluentbit--repo--debian--key_fingerprint"></a>`key_fingerprint`

Data type: `String[1]`

GPG key identifier of the repository

##### <a name="-fluentbit--repo--debian--key_location"></a>`key_location`

Data type: `Stdlib::HTTPUrl`

GPG key URI

##### <a name="-fluentbit--repo--debian--flavour"></a>`flavour`

Data type: `String[1]`

e.g. Debian/Ubuntu

Default value: `$facts['os']['distro']['id']`

##### <a name="-fluentbit--repo--debian--release"></a>`release`

Data type: `String[1]`

distribution code name

Default value: `$facts['os']['distro']['codename']`

### <a name="fluentbit--repo--redhat"></a>`fluentbit::repo::redhat`

Manage yum repo

### <a name="fluentbit--service"></a>`fluentbit::service`

Manage fluent-bit service

## Defined types

### <a name="fluentbit--pipeline"></a>`fluentbit::pipeline`

Configures fluentbit pipeline (input, output or filter)

* **Note** This resource add extra configuration elements for some combinations of
type-plugin_names, like db configuration for input plugins, or upstream configuration
for output-forward plugin

* **See also**
  * https://docs.fluentbit.io/manual/administration/configuring-fluent-bit/yaml/configuration-file#config_pipeline

#### Examples

##### 

```puppet
fluentbit::pipeline { 'input-dummy':
  pipeline => 'input',
  plugin   => 'dummy',
}
```

##### 

```puppet
fluentbit {
  input_plugins => {
    'input-dummy' => { 'plugin' => 'dummy' },
  },
}
```

#### Parameters

The following parameters are available in the `fluentbit::pipeline` defined type:

* [`pipeline`](#-fluentbit--pipeline--pipeline)
* [`plugin`](#-fluentbit--pipeline--plugin)
* [`order`](#-fluentbit--pipeline--order)
* [`properties`](#-fluentbit--pipeline--properties)

##### <a name="-fluentbit--pipeline--pipeline"></a>`pipeline`

Data type: `Fluentbit::PipelineType`

Defines the pipeline type to be configured

##### <a name="-fluentbit--pipeline--plugin"></a>`plugin`

Data type: `String[1]`

fluent-bit plugin name to be used

##### <a name="-fluentbit--pipeline--order"></a>`order`

Data type: `Integer`

Order to be applied to concat::fragment

Default value: `10`

##### <a name="-fluentbit--pipeline--properties"></a>`properties`

Data type: `Hash[String, Any]`

Hash of rest of properties needed to configure the pipeline-plugin

Default value: `{}`

### <a name="fluentbit--upstream"></a>`fluentbit::upstream`

Configures fluentbit upstream

* **See also**
  * https://docs.fluentbit.io/manual/administration/configuring-fluent-bit/classic-mode/upstream-servers

#### Examples

##### 

```puppet
fluentbit::upstream { 'upstreams':
  nodes  => {
    'n1' => { 'host' => '127.0.0.1', port => 1234 },
    'n2' => { 'host' => '127.0.0.1', port => 1235 },
  },
}
```

#### Parameters

The following parameters are available in the `fluentbit::upstream` defined type:

* [`upstream_name`](#-fluentbit--upstream--upstream_name)
* [`nodes`](#-fluentbit--upstream--nodes)
* [`config_dir`](#-fluentbit--upstream--config_dir)

##### <a name="-fluentbit--upstream--upstream_name"></a>`upstream_name`

Data type: `String[1]`

Name to be assigned to upstream, defaults to resource namevar

Default value: `$name`

##### <a name="-fluentbit--upstream--nodes"></a>`nodes`

Data type: `Hash[String, Fluentbit::UpstreamNode]`

Hash of nodes assigned to this upstream

##### <a name="-fluentbit--upstream--config_dir"></a>`config_dir`

Data type: `Stdlib::Absolutepath`

Absolute path to config directory

Default value: `$fluentbit::config_dir`

## Data types

### <a name="Fluentbit--Field_decoder"></a>`Fluentbit::Field_decoder`

The Fluentbit::Field_decoder data type.

Alias of

```puppet
Struct[{
  decoder => Enum['json'],
  field   => String[1],
}]
```

### <a name="Fluentbit--Field_type"></a>`Fluentbit::Field_type`

The Fluentbit::Field_type data type.

Alias of

```puppet
Struct[{
  type  => Enum['string', 'integer', 'bool', 'float', 'hex'],
  field => String[1],
}]
```

### <a name="Fluentbit--Loglevel"></a>`Fluentbit::Loglevel`

The Fluentbit::Loglevel data type.

Alias of `Enum['error', 'warning', 'info', 'debug', 'trace']`

### <a name="Fluentbit--MultilineParser"></a>`Fluentbit::MultilineParser`

The Fluentbit::MultilineParser data type.

Alias of

```puppet
Hash[String, Struct[{
  type                    => Enum['regex'],
  rules                   => Array[Struct[{
                            state      => String[1],
                            regex      => String[1],
                            next_state => String[1],
                          }]],
  Optional[parser]        => String[1],
  Optional[key_content]   => String[1],
  Optional[flush_timeout] => Integer,
}]]
```

### <a name="Fluentbit--Parser"></a>`Fluentbit::Parser`

The Fluentbit::Parser data type.

Alias of

```puppet
Hash[String, Struct[{
  format                 => Enum['json', 'regex', 'ltsv', 'logfmt'],
  Optional[regex]        => String[1],
  Optional[time_key]     => String[1],
  Optional[time_format]  => String[1],
  Optional[time_offset]  => String[1],
  Optional[time_keep]    => Boolean,
  Optional[types]        => Array[Fluentbit::Field_type],
  Optional[decode_field] => Array[Fluentbit::Field_decoder],
}]]
```

### <a name="Fluentbit--PipelinePlugin"></a>`Fluentbit::PipelinePlugin`

The Fluentbit::PipelinePlugin data type.

Alias of

```puppet
Hash[String, Struct[{
  plugin               => String[1],
  Optional[pipeline]   => Fluentbit::PipelineType,
  Optional[order]      => Integer,
  Optional[properties] => Hash,
}]]
```

### <a name="Fluentbit--PipelineType"></a>`Fluentbit::PipelineType`

The Fluentbit::PipelineType data type.

Alias of `Enum['input', 'filter', 'output']`

### <a name="Fluentbit--Stream"></a>`Fluentbit::Stream`

The Fluentbit::Stream data type.

Alias of

```puppet
Hash[String, Struct[{
    exec => String[1],
  }]]
```

### <a name="Fluentbit--UpstreamNode"></a>`Fluentbit::UpstreamNode`

The Fluentbit::UpstreamNode data type.

Alias of

```puppet
Struct[{
  host => String[1],
  port => Integer,
  Optional[tls]  => Enum['On', 'Off'],
  Optional[tls_verify] => Enum['On', 'Off']
}]
```

